
#include <string>

#include <secureid.h>
#include <uuid/uuid.h>

namespace ssod {
    class pluginApi {
        /*Basic methods*/
        virtual void init()=0;
        virtual const char *getVersion()=0;
        virtual const char *getName()=0;
        virtual const char *Athor()=0;

        /*App methods*/
        virtual uuid_t *AppAuth(uuid_t appidentfier);
        virtual bool    AppCheckSession(const uuid_t *session);

        /*User Methods*/
        virtual uuid_t     *Auth(const char *username,const char *password)=0;
        virtual bool        CheckSession(const uuid_t *session)=0;
        virtual SID         getUid(const char *name)=0;
        virtual const char *getName(SID uid)=0;
        virtual int         getAvatar(std::string pic)=0;
    };

    class Plugin {

    };
};
